#
# makefile to build SND32 Demos Watcom C/C++ Version
#
# Copyright (c) 1997 Ken Graham, All Rights Reserved
#
.EXTENSIONS:
.EXTENSIONS: .obj .rbj .c .h 
#
CC 	= wcl386
CFLAG	= /bt=dos4gw /l=dos4g /j /zq /zu /w3 /fm
CFLAGS	= /5s /d1 /oneatx $(CFLAG)
CFLAGR 	= /5r /d1 /oalrt $(CFLAG)
LIBS	= SND32S.LIB
LIBR	= SND32R.LIB
OBJS	= obj
OBJR	= rbj
INC     = portable.h snd32.h # sndext.h 
EXES    = midplay.exe  parsemid.exe playsnd.exe playsnds.exe 
EXER    = midplayr.exe playsndr.exe
#
# Rules
#

.c.obj:
	$(CC) -c $(CFLAGS) -Fo=$@ $*.c

.c.rbj:
	$(CC) -c $(CFLAGR) -Fo=$@ $*.c

#
# Targets
#
all:    $(EXES) $(EXER)

#
# Stack Passing EXEs
#
midplay.exe:    midplay.c $(INC) $(LIBS)
        $(CC) $(CFLAGS) midplay.c $(LIBS)

parsemid.exe:   parsemid.c $(INC) snd_gm.h
        $(CC) $(CFLAGSD) /k16384 parsemid.c

playsnd.exe:    playsnd.c $(INC) $(LIBS)
        $(CC) $(CFLAGS) playsnd.c $(LIBS)

playsnds.exe:   playsnds.c $(INC) $(LIBS)
        $(CC) $(CFLAGS) playsnds.c $(LIBS)

#
# Register Passing EXEs
#
midplayr.exe:    midplayr.obj $(LIBR)
        $(CC) $(CFLAGR) midplayr.obj $(LIBR)

midplayr.obj:    midplay.c $(INC)
        $(CC) -c $(CFLAGR) /Fo=midplayr.obj midplay.c

playsndr.exe:   playsndr.obj $(LIBR)
        $(CC) $(CFLAGR) playsndr.obj $(LIBR)

playsndr.obj:   playsnd.c $(INC)
        $(CC) -c $(CFLAGR) playsnd.c /Fo=playsndr.obj


