/************************************************************
 *                                                          *
 * olp3.h                                                   *
 *                                                          *
 *----------------------------------------------------------*
 * OPL3 chip definitions                                    *
 *----------------------------------------------------------*
 * Copyright (c) 1994,1996 Ken Graham, All Rights Reserved  *
 *                                                          *
 * Redistribution and use in source and binary forms,       *
 * without modification, are permitted provided that the    *
 * following conditions are met:                            *
 * 1. Redistributions of source code must retain the above  *
 *    copyright notice, this list of conditions and the     *
 *    following disclaimer.                                 *
 * 2. Redistributions in binary form must reproduce the     *
 *    above copyright notice, this list of conditions and   *
 *    the following disclaimer in the documentation and/or  *
 *    other materials provided with the distribution.       *
 *                                                          *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY  *
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT        *
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY    *
 * AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.     *
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,   *
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR             *
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,    *
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF     *
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER *
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN        *
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING           *
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE   *
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY *
 * OF SUCH DAMAGE.                                          *
 *                                                          *
 ************************************************************
 *
 * $Author:   kag  $
 * $Revision:   1.1  $
 * $Date:   02 May 1997 18:38:32  $
 *
 * History:
 *
 * $Log:   D:/snd32/midi2/archives/opl3.h_v  $
   
      Rev 1.1   02 May 1997 18:38:32   kag
   No change.
   
      Rev 1.0   18 May 1996 16:45:54   kag
   Initial revision.
 * 
 ************************************************************/


#if !defined(_OPL_H_)
#define _OPL_H_

#if !defined(_PORTABLE_H_)
#include "portable.h"
#endif

#define OPL_STATUS  0x00
#define OPL_ENABLE  0x01
#define OPL_TIMER1  0x02
#define OPL_TIMER2  0x03
#define OPL_IRQ     0x04        /* applies to LEFT_CHANNEL ONLY     */
#define OPL_MODE    0x05        /* applies to RIGHT_CHANNEL ONLY    */
#define OPL_CSW     0x08
#define OPL_KSR     0x20        /* 0x20-0x35    */
#define OPL_KSL     0x40        /* 0x40-0x55    */
#define OPL_ADR     0x60        /* 0x60-0x75    */
#define OPL_SRR     0x80        /* 0x80-0x95    */
#define OPL_FREQ    0xA0        /* 0xA0-0xA8    */
#define OPL_KEYON   0xB0        /* 0xB0-0xB8    */
#define OPL_PERC    0xBD
#define OPL_FB      0xC0        /* 0xC0-0xC8    */
#define OPL_WAVE    0xE0        /* 0xE0-0xF5    */

typedef struct {
    BYTE    voice;      /* OPL2(3) voice number         */
    BYTE    mode;       /* 0 = N/A, 2 = 2 OP, 4 = 4 OP  */
    WORD    ioport;     /* I/O port offset (0 = left)   */
    BYTE    op[4];      /* operator address offsets     */
} VOICE_INFO;

#define LEFT_SIDE   0
#define RIGHT_SIDE  2

#define ReadFM()    ((BYTE)inp(sb_base))
#define ReadFM2()   ((BYTE)inp(sb_base+2))

#endif
